function JULDAY_365, MONTH, DAY, YEAR, Hour, Minute, Second

mdays = [1,32,60,91,121,152,182,213,244,274,305,335] 


for i=0,n_elements(month)-1 do begin
  if (month[i] le 12) then begin
    m = month[i]
    y = 0
  endif else begin
    m = month[i] mod 12
    y = month[i]/12
  endelse
  if i eq 0 then mm = m else mm = [mm,m]
  if i eq 0 then yy = y else yy = [yy,y]

endfor

doy = day + mdays[mm-1] -1 + 365*yy

dayfrac = ( hour/24.d ) + (minute/1440.d) + (second/86400.d)

julday = (year-1)*365.d + double(doy-1) + dayfrac

; Add a small offset so we get the hours, minutes, & seconds back correctly
; if we convert the Julian dates back. This offset is proportional to the
; Julian date, so small dates (a long, long time ago) will be "more" accurate.
eps = (MACHAR(/DOUBLE)).eps
eps = eps*ABS(julday) > eps

julday = julday + eps

return, julday

end

pro test_julday_365

mon = [1,12,10]
day = [23,10,1]
year = [0,2222,5050]
hr = [0,23,6]
min = [55,7,0]
sec = [23d,19d,0d]

j = julday_365( mon,day,year,hr,min,sec )

print, 'j = ',j

caldat_365, j, m,d,y,h,i,s


n = n_elements(mon)

for ii=0,n-1 do begin
  print,mon[ii],day[ii],year[ii],hr[ii],min[ii],fix(sec[ii])
  print,m[ii],d[ii],y[ii],h[ii],i[ii],fix(s[ii])
  if ( mon[ii] ne m[ii] or $
       day[ii] ne d[ii] or $
       year[ii] ne y[ii] or $
       hr[ii] ne h[ii] or $
       min[ii] ne i[ii] or $
       fix(sec[ii]) ne fix(s[ii]) ) then $ 
         print, 'FAILURE' else print, 'SUCCESS'

endfor

end
